Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ForwardingSet<E>

    java.lang.Object
      com.google.common.collect.ForwardingObject
          com.google.common.collect.ForwardingCollection<E>
              com.google.common.collect.ForwardingSet<E>

All Implemented Interfaces:
  Iterable<E>, Collection<E>, Set<E>

Direct Known Subclasses:
  ForwardingSortedSet

    @GwtCompatible
    public abstract class ForwardingSet<E>

extends ForwardingCollection<E>
implements Set<E>

A set which forwards all its method calls to another set. Subclasses should override one or more methods to modify the behavior of the backing set as desired per the decorator pattern.

Warning: The methods of `ForwardingSet` forward indiscriminately to the methods of the delegate. For example, overriding `ForwardingCollection.add(E)` alone will not change the behavior of `ForwardingCollection.addAll(java.util.Collection)`, which can lead to unexpected behavior. In this case, you should override `addAll` as well, either providing your own implementation, or delegating to the provided `standardAddAll` method.

The `standard` methods are not guaranteed to be thread-safe, even when all of the methods that they depend on are thread-safe.

Since:
  2.0 (imported from Google Collections Library)
Author:
  Kevin Bourrillion, Louis Wasserman

Constructor Summary
`protected` | `ForwardingSet()` Constructor for use by subclasses.

Method Summary
`protected abstract Set<E>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
`boolean` | `equals(Object object)`
`int` | `hashCode()`
`protected boolean` | `standardEquals(Object object)` A sensible definition of `equals(java.lang.Object)` in terms of `ForwardingCollection.size()` and `ForwardingCollection.containsAll(java.util.Collection)`.
`protected int` | `standardHashCode()` A sensible definition of `hashCode()` in terms of `ForwardingCollection.iterator()`.

Methods inherited from class com.google.common.collect.ForwardingCollection
`add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, removeAll, retainAll, size, standardAddAll, standardClear, standardContains, standardContainsAll, standardIsEmpty, standardRemove, standardRemoveAll, standardRetainAll, standardToArray, standardToArray, standardToString, toArray, toArray`

Methods inherited from class com.google.common.collect.ForwardingObject
`toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Set
`add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray`

Constructor Detail

### ForwardingSet

    protected ForwardingSet()

  Constructor for use by subclasses.

Method Detail

### delegate

    protected abstract Set<E> delegate()

  Description copied from class: `ForwardingObject`
  Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `delegate()`. Concrete subclasses override this method to supply the instance being decorated.

  Specified by:
    `delegate` in class `ForwardingCollection<E>`

### equals

    public boolean equals(@Nullable
                          Object object)

  Specified by:
    `equals` in interface `Collection<E>`
  Specified by:
    `equals` in interface `Set<E>`
  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Specified by:
    `hashCode` in interface `Collection<E>`
  Specified by:
    `hashCode` in interface `Set<E>`
  Overrides:
    `hashCode` in class `Object`

### standardEquals

    @Beta
    protected boolean standardEquals(@Nullable
                                          Object object)

  A sensible definition of `equals(java.lang.Object)` in terms of `ForwardingCollection.size()` and `ForwardingCollection.containsAll(java.util.Collection)`. If you override either of those methods, you may wish to override `equals(java.lang.Object)` to forward to this implementation.

  Since:
    7.0

### standardHashCode

    @Beta
    protected int standardHashCode()

  A sensible definition of `hashCode()` in terms of `ForwardingCollection.iterator()`. If you override `ForwardingCollection.iterator()`, you may wish to override `equals(java.lang.Object)` to forward to this implementation.

  Since:
    7.0

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2011. All Rights Reserved.